/*
 * Copyright (c) 2022, Technische Universität Kaiserslautern
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Authors:
 *    Iron Prando da Silva
 */

#include "poolcontroller.h"
#include <algorithm>

PoolController::PoolController(const uint poolSize, const std::vector<PoolEntry>& dependencies)
: mDependencies(mAuxSortInput(dependencies)) 
{
    mPoolSize = poolSize;

}

void PoolController::clear() {
    mPool.clear();
    mCount = 0;

}

void PoolController::push(DBDependencyEntry dep) {
    mPool.push_back(dep);
    mCount++;

}

void PoolController::increment() {
    mCount++;
}

void PoolController::merge(std::vector<DBDependencyEntry>& depEntries) {
    if(mCount >= mPoolSize) {
        depEntries.insert( depEntries.end(), mPool.begin(), mPool.end() );
    }
}

uint PoolController::getBusyTime(const StringMapper& phaseName) {
    PoolEntry v{phaseName, 0};

    auto entryIt = std::lower_bound(
        mDependencies.begin(), 
        mDependencies.end(), 
        v,
        [](const PoolEntry& e1, const PoolEntry& e2) {
            return e1.first < e2.first;
        }
    );

    if (entryIt->first == phaseName) {
        return entryIt->second;
    } else {
        return 0;
    }
}

std::vector<PoolEntry> PoolController::mAuxSortInput(std::vector<PoolEntry> vec) {
    std::sort(
        vec.begin(), 
        vec.end(),
        [](const PoolEntry& e1, const PoolEntry& e2) {
            return e1.first < e2.first;
        }
    );

    return vec;
}